/*
 *	main.c
 *
 *	ԊOXMODEM
 *	Copyright (C) 2002 Naoyuki Sawa
 *
 *	* Sun Oct 3 14:10:00 JST 2002 Naoyuki Sawa
 *	- 1st [XB
 */
#include "app.h"

int
pceAppNotify(int type, int param)
{
extern unsigned char _def_vbuff[];
	switch(type) {
	case APPNF_SMSTART:
		return APPNR_ACCEPT;
	case APPNF_SMREQVBUF:
		pceLCDSetBuffer(_def_vbuff);
		return APPNR_ACCEPT;
	case APPNF_STANDBY:
		return APPNR_REJECT; /* ԊOʐM̉\̂ŁAX^oC֎~ */
	}
	return APPNR_IGNORE;
}

/****************************************************************************
 *	萔E^
 ****************************************************************************/

#define FPS		20			/* t[[g */
#define SEC(s)		((int)(FPS * (s)))	/* b->t[ϊ */

#define TIMEOUT		SEC(3)/*SEC(10)*/	/* M^CAEg(zg10b) */
#define DELAY		(SEC(100) / 1000)	/* MMւ̐؂芷fBC(̎M悤) */
#define CANCEL_DELAY	SEC(1)			/* CANMÓȂMI悤ɁA߂ɑ҂܂  */

/****************************************************************************
 *	ϐ
 ****************************************************************************/

unsigned char vbuff[DISP_X * DISP_Y];	/* zVRAM */

FILEINFO files[MAXDIR];			/* t@CXg */
int n_files;				/* t@CXg̗vf */
int cursel;				/* It@CCfNX */
int curtop;				/* ʍŏĩt@CCfNX */

typedef struct _XBUFFER {
	char fname[24];			/* + 0`23:t@C */
	int orglen;			/* +24`27:kÕoCg */
	int cmplen;			/* +28`31:k̃oCg(0:k) */
	unsigned char data[0x10000-32];	/* +32`  :kf[^ */
} XBUFFER;				/* 128̐{TCYłȂ΂܂ */
XBUFFER xb;

#define SOH	'\x01'
#define EOT	'\x04'
#define ACK	'\x06'
#define NAK	'\x15'
#define CAN	'\x18'
typedef struct _XMODEM {
	unsigned char soh;		/* SOH/EOT/CAN */
	unsigned char seq;		/*   1,  2,  3,... */
	unsigned char _seq;		/* 254,253,252,... */
	unsigned char data[128];
	unsigned char sum;		/* data[0]+data[1]+,...,+data[127] */
} XMODEM;
XMODEM xm;

/****************************************************************************
 *	֐錾
 ****************************************************************************/

int sFontPrintf(const char* fmt, ...);
void info(const char* fmt, ...);
int wait_cancel(int frames, int cancel_mask);
int x_send();
int x_recv();

/****************************************************************************
 *	main
 ****************************************************************************/

int
main()
{
	int i, x, y, joy;
	const char* s;
	FILEINFO fi;

	/* ʓIȏB */
	pceLCDDispStop();
	pceLCDSetBuffer(vbuff);
	pceAppSetProcPeriod(1000 / FPS);
	pceLCDDispStart();
	pceFontSetType(0); /* sfont.cĝŁAtHg^Cv͌ŒI */

	/* C[vB */
	for(;;) {
		/* t@CXg擾܂B */
		pceFileFindOpen(&fi);
		n_files = 0;
		while(n_files < MAXDIR) {
			if(!pceFileFindNext(&fi)) break;
			if(strcmp(fi.filename, "startup.pex") == 0) continue;
			if(strncmp(fi.filename, xb.fname, sizeof xb.fname) == 0) cursel = n_files; /* x_read()ō쐬t@CI */
			memcpy(&files[n_files++], &fi, sizeof(FILEINFO));
		}
		pceFileFindClose(&fi);
		if(cursel < 0          ) cursel = 0          ;
		if(cursel > n_files - 1) cursel = n_files - 1;

		/* t@CXgʂ̃[vB */
		for(;;) {
			yield();

			/* L[̏B */
			joy = pcePadGet();
			if(joy & TRG_SELECT) exit(0);
			if(n_files != 0) {
				if(joy & TRG_UP) cursel--;
				if(joy & TRG_DN) cursel++;
				if(joy & TRG_LF) cursel -= 5;
				if(joy & TRG_RI) cursel += 5;
				if(cursel < 0          ) cursel = 0          ;
				if(cursel > n_files - 1) cursel = n_files - 1;
				if(cursel < curtop    ) curtop = cursel    ;
				if(cursel > curtop + 5) curtop = cursel - 5;
				if(joy & TRG_A) {
					x_send();
					memset(&xb, 0, sizeof xb); /* cursel͕ύXȂ */
				}
			}
			if(joy & TRG_B) {
				if(x_recv() != 0) {
					memset(&xb, 0, sizeof xb); /* scurselύXȂ */
				}
				break; /* t@CXg蒼 */
			}

			/* t@CXg\܂B */
			memset(vbuff, 0, sizeof vbuff);
			if(n_files == 0) {
				s = "t@C܂";
				sFontStatus.x = (DISP_X -  4 * strlen(s)) / 2;
				sFontStatus.y = (DISP_Y - 10            ) / 2;
				sFontStatus.spr = 0;
				sFontPutStr(s);
			} else {
				x = -4;
				y = 14 - 10 * curtop;
				for(i = 0; i < n_files; i++) {
					if(i == cursel) {
						sFontStatus.spr = 2;
					} else {
						sFontStatus.spr = 0;
					}
					sFontStatus.x = x;
					sFontStatus.y = y;
					/* 00000000001111111111222222222233 */
					/* 01234567890123456789012345678901 */
					/*   |-----filename-----||-size-|   */
					sFontPrintf("  %-20.20s %8d  ", files[i].filename, files[i].length);
					y += 10;
				}
			}
			/*   OPQRSTUVWXOPQRST*/
			s = "=======ԊOwlncdl=======";
			sFontStatus.x = 0;
			sFontStatus.y = 0;
			sFontStatus.spr = 2;
			sFontPutStr(s);
			if(n_files == 0) {
				/*   OPQRSTUVWXOPQRST*/
				s = " [SELECT]I  [B]M          ";
			} else {
				/*   OPQRSTUVWXOPQRST*/
				s = " [SELECT]I  [B]M  [A]M ";
			}
			sFontStatus.x = 0;
			sFontStatus.y = DISP_Y - 10;
			sFontPutStr(s);
			pceLCDTrans();
		}
	}

	return 0;
}

/****************************************************************************
 *	sFontPrintf
 ****************************************************************************/

int
sFontPrintf(const char* fmt, ...)
{
extern unsigned char _def_vbuff[]; /* WJɗp */
	int result;
	va_list ap;

	va_start(ap, fmt);
	result = vsprintf(_def_vbuff, fmt, ap);
	va_end(ap);

	sFontPutStr(_def_vbuff);

	return result;
}

/****************************************************************************
 *	info
 ****************************************************************************/

void
info(const char* fmt, ...)
{
extern unsigned char _def_vbuff[]; /* WJɗp */
	va_list ap;

	va_start(ap, fmt);
	vsprintf(_def_vbuff, fmt, ap);
	va_end(ap);

	memset(vbuff, 0, sizeof vbuff);
	sFontStatus.x = (DISP_X -  4 * strlen(_def_vbuff)) / 2;
	sFontStatus.y = (DISP_Y - 10                     ) / 2;
	sFontStatus.spr = 0;
	sFontPutStr(_def_vbuff);
	pceLCDTrans();
}

/****************************************************************************
 *	wait_cancel
 ****************************************************************************/

int
wait_cancel(int frames, int cancel_mask)
{
	int i;
	for(i = 0; i < frames; i++) {
		yield();
		if(pcePadGet() & cancel_mask) return 1;
	}
	return 0;
}

/****************************************************************************
 *	x_send
 ****************************************************************************/

int
x_send()
{
	int retval, i, len, dstlen, srclen, xlen, seq, all;
	unsigned char *tmpbuf, *xptr;
	FILEINFO* fi;
	FILEACC fa;

	if(cursel < 0 || n_files - 1 < cursel) return -1; /* ̂Ƃ날肦ȂAÔ */
	fi = &files[cursel];
	strncpy(xb.fname, fi->filename, sizeof xb.fname); /* yt@Cz */

	info("t@Cǂݍݒc");
	retval = pceFileOpen(&fa, fi->filename, FOMD_RD);
	if(retval != 0) {
		info("%sJ܂", fi->filename);
		goto ERR;
	}
	srclen = fa.fsize;
	xb.orglen = srclen; /* ykÕoCgz */
	tmpbuf = (unsigned char*)malloc(srclen);
	if(tmpbuf == NULL) {
		/*    OPQRSTUVWXOPQRST*/
		info("sł");
		pceFileClose(&fa);
		goto ERR;
	}
	retval = file_read(&fa, tmpbuf, 0, srclen);
	if(retval != srclen) {
		/*    OPQRSTUVWXOPQRST*/
		info("t@Cǂݍ݂Ɏs܂");
		pceFileClose(&fa);
		free(tmpbuf);
		goto ERR;
	}
	pceFileClose(&fa);

	info("Mf[^kc");
	len = strlen(fi->filename);
	if(len >= 4 && ( /* zlibňkĂ`Ȃ疳kőM */
	   strcmp(&fi->filename[len - 4], ".pex") == 0 ||
	   strcmp(&fi->filename[len - 4], ".png") == 0 ||
	   strcmp(&fi->filename[len - 4], ".zip") == 0 ||
	   strcmp(&fi->filename[len - 4], ".lzh") == 0 ||
	   strcmp(&fi->filename[len - 4], ".tgz") == 0)) goto NO_COMPRESS;
	dstlen = sizeof xb.data;
	retval = my_compress(xb.data, &dstlen, tmpbuf, srclen);
	if(retval != Z_OK) goto NO_COMPRESS; /* ksȂ疳kőM */
	if(dstlen < srclen) {
		xb.cmplen = dstlen; /* yk̃oCgz */
	} else {
NO_COMPRESS:
		if(srclen > sizeof xb.data) {
			/*    OPQRSTUVWXOPQRST*/
			info("t@CTCY傫܂");
			free(tmpbuf);
			goto ERR;
		}
		memcpy(xb.data, tmpbuf, srclen);
		xb.cmplen = 0; /* yk̃oCgz(0:k) */
	}
	free(tmpbuf);

	xptr = (unsigned char*)&xb;
	xlen = 32 + (xb.cmplen ? xb.cmplen : xb.orglen);
	if(xlen & 127) { /* 128oCgPʂɐ؂グA^ZŃpfBO */
		memset(xptr + xlen, '\x1a', 128 - (xlen & 127));
		xlen += 128 - (xlen & 127);
	}
	seq = 1; /* XMODEM̃ubNԍ1n܂܂ */
	all = xlen / 128;

	/* ŏNAK҂B */
	for(;;) {
		info("ʐMJnҁc");
		pceIRStartRx(&xm.soh, 1);
		for(;;) {
			yield();
			if(!pceIRGetStat()) break;
			if(pcePadGet() & TRG_MASK) {
				pceIRStop();
				info("MLZc");
				xm.soh = CAN;
				wait_cancel(CANCEL_DELAY, 0);
				pceIRStartTx(&xm.soh, 1);
				while(pceIRGetStat()) yield();
				info("MLZ܂");
				goto ERR;
			}
		}
		if(xm.soh == NAK) {
			break; /* ubNMցB */
		} else if(xm.soh == CAN) {
			info("MLZ܂");
			goto ERR;
		}
		/* NAKCANȊO͖܂B */
	}
	while(xlen > 0) {
		/* ubNMB */
		info("ubN[%d/%d]쐬c", seq, all);
		xm.soh = SOH;
		xm.seq = seq;
		xm._seq = ~seq;
		xm.sum = 0;
		for(i = 0; i < 128; i++) {
			xm.data[i] = xptr[i];
			xm.sum += xptr[i];
		}
		info("ubN[%d/%d]Mc", seq, all);
		wait_cancel(DELAY, 0);
		pceIRStartTx((unsigned char*)&xm, sizeof xm);
		for(;;) {
			yield();
			if(!pceIRGetStat()) break;
			if(pcePadGet() & TRG_MASK) {
				while(pceIRGetStat()) yield(); /* pceIRStop()Ŏ~߂ƎMCANȂ */
				info("MLZc");
				xm.soh = CAN;
				wait_cancel(CANCEL_DELAY, 0);
				pceIRStartTx(&xm.soh, 1);
				while(pceIRGetStat()) yield();
				info("MLZ܂");
				goto ERR;
			}
		}

		/* ҂B */
		info("ubN[%d/%d]ҁc", seq, all);
		pceIRStartRx(&xm.soh, 1);
		for(i = TIMEOUT; i > 0; i--) {
			yield();
			if(!pceIRGetStat()) break;
			if(pcePadGet() & TRG_MASK) {
				pceIRStop();
				info("MLZc");
				xm.soh = CAN;
				wait_cancel(CANCEL_DELAY, 0);
				pceIRStartTx(&xm.soh, 1);
				while(pceIRGetStat()) yield();
				info("MLZ܂");
				goto ERR;
			}
		}
		if(i == 0) continue; /* ^CAEg */
		if(xm.soh == ACK) {
			/* ̃ubNM֐i */
			seq++;
			xptr += 128;
			xlen -= 128;
		} else if(xm.soh == CAN) {
			info("MLZ܂");
			goto ERR;
		}
		/* ACKCANȊO͑SčđMvƌȂ܂B */
	}
	for(;;) {
		/* IʒmMB */
		info("Ic");
		xm.soh = EOT;
		wait_cancel(DELAY, 0);
		pceIRStartTx(&xm.soh, 1);
		while(pceIRGetStat()) yield();

		/* ҂B */
		info("Iҁc");
		pceIRStartRx(&xm.soh, 1);
		for(i = TIMEOUT; i > 0; i--) {
			yield();
			if(!pceIRGetStat()) break;
			if(pcePadGet() & TRG_MASK) {
				pceIRStop();
				info("MLZc");
				xm.soh = CAN;
				wait_cancel(CANCEL_DELAY, 0);
				pceIRStartTx(&xm.soh, 1);
				while(pceIRGetStat()) yield();
				info("MLZ܂");
				goto ERR;
			}
		}
		if(i == 0) continue; /* ^CAEg */
		if(xm.soh == ACK) {
			break; /* M */
		} else if(xm.soh == CAN) {
			info("MLZ܂");
			goto ERR;
		}
		/* ACKCANȊO͑SčđMvƌȂ܂B */
	}

	pceIRStop();
	return 0;
ERR:
	pceIRStop();
	do {
		yield();
	} while(!(pcePadGet() & TRG_MASK));
	return -1;
}

/****************************************************************************
 *	x_recv
 ****************************************************************************/

int
x_recv()
{
	int retval, i, orglen, cmplen, xlen, seq;
	unsigned char *tmpbuf, *xptr;
	unsigned char sum;
	FILEACC fa;

	xptr = (unsigned char*)&xb;
	xlen = 0;
	seq = 1; /* XMODEM̃ubNԍ1n܂܂ */

	/* ŏNAKMB */
	info("ʐMJnc");
	xm.soh = NAK;
	wait_cancel(DELAY, 0);
	pceIRStartTx(&xm.soh, 1);
	while(pceIRGetStat()) yield();

	for(;;) {
		/* ubNMB */
		info("ubN[%d]Mc", seq);
		xm.soh = 0;
		pceIRStartRx((unsigned char*)&xm, sizeof xm);
		for(i = TIMEOUT; i > 0; i--) {
			yield();
			if(!pceIRGetStat()) break;
			if(pcePadGet() & TRG_MASK) {
				pceIRStop();
				info("MLZc");
				xm.soh = CAN;
				wait_cancel(CANCEL_DELAY, 0);
				pceIRStartTx(&xm.soh, 1);
				while(pceIRGetStat()) yield();
				info("MLZ܂");
				goto ERR;
			}
			if(xm.soh && xm.soh != SOH) break;
		}
		if(xm.soh == SOH) {
			/* MubNB */
			info("MubNc");
			if((xm.seq & 0xff) != (~xm._seq & 0xff)) goto SEND_NAK; /* ubNԍG[ */
			if(xm.seq == ((seq - 1) & 0xff)) goto SEND_ACK; /* ubNAŎ󂯎Aڂ𖳎 */
			if(xm.seq != ( seq      & 0xff)|| /* ubNԍ̓ꂽB񕜕s\ */
			  (xlen + 128 > sizeof xb)) {     /* TCYI[o[ */
				info("MLZc");
				xm.soh = CAN;
				wait_cancel(CANCEL_DELAY, 0);
				pceIRStartTx(&xm.soh, 1);
				while(pceIRGetStat()) yield();
				info("MɎs܂");
				goto ERR;
			}
			sum = 0;
			for(i = 0; i < 128; i++) sum += xm.data[i];
			if(xm.sum != sum) goto SEND_NAK; /* `FbNTG[ */
			/* Mf[^i[܂B */
			memcpy(xptr, xm.data, 128);
			/* ̃ubNM֐iށB */
			seq++;
			xptr += 128;
			xlen += 128;
SEND_ACK:
			/* MmFB */
			info("MmFc");
			xm.soh = ACK;
			wait_cancel(DELAY, 0);
			pceIRStartTx(&xm.soh, 1);
			while(pceIRGetStat()) yield();
		} else if(xm.soh == EOT) {
			/* ImFB */
			info("ImFc");
			xm.soh = ACK;
			wait_cancel(DELAY, 0);
			pceIRStartTx(&xm.soh, 1);
			while(pceIRGetStat()) yield();
			/* M */
			break;
		} else if(xm.soh == CAN) {
			info("MLZ܂");
			goto ERR;
		} else {
SEND_NAK:
			/* đMvB */
			info("đMvc");
			xm.soh = NAK;
			wait_cancel(DELAY, 0);
			pceIRStartTx(&xm.soh, 1);
			while(pceIRGetStat()) yield();
		}
	}

	info("Mf[^WJc");
	if(xlen < 32) { /* wb_s */
		/*    OPQRSTUVWXOPQRST*/
		info("Mf[^Ă܂");
		goto ERR;
	}
	orglen = xb.orglen;
	cmplen = xb.cmplen;
	tmpbuf = (unsigned char*)malloc(orglen);
	if(tmpbuf == NULL) {
		/*    OPQRSTUVWXOPQRST*/
		info("sł");
		goto ERR;
	}
	if(cmplen) { /* k */
		retval = uncompress(tmpbuf, (long*)&orglen, xb.data, cmplen);
		if(retval != Z_OK || orglen != xb.orglen) {
			/*    OPQRSTUVWXOPQRST*/
			info("Mf[^Ă܂");
			free(tmpbuf);
			goto ERR;
		}
	} else { /* kȂ */
		memcpy(tmpbuf, xb.data, orglen);
	}

	info("%sݒc", xb.fname);
	retval = pceFileCreate(xb.fname, orglen);
	if(retval != 0) {
		info("%s쐬ł܂", xb.fname);
		free(tmpbuf);
		goto ERR;
	}
	retval = pceFileOpen(&fa, xb.fname, FOMD_WR);
	if(retval != 0) {
		info("%sJ܂", xb.fname);
		pceFileDelete(xb.fname);
		free(tmpbuf);
		goto ERR;
	}
	retval = file_write(&fa, tmpbuf, 0, orglen);
	if(retval != orglen) {
		/*    OPQRSTUVWXOPQRST*/
		info("t@C݂Ɏs܂");
		pceFileClose(&fa);
		pceFileDelete(xb.fname);
		free(tmpbuf);
		goto ERR;
	}
	pceFileClose(&fa);
	free(tmpbuf);

	pceIRStop();
	return 0;
ERR:
	pceIRStop();
	do {
		yield();
	} while(!(pcePadGet() & TRG_MASK));
	return -1;
}

